<template>
  <GenericLayout>
    <template #header>
      <Header
        :back-button="true"
        :title="pageTitle"
      />
    </template>

    <template
      #page-content
    >
      <div class="full-height column">
        <template v-if="isDesktopPlatform">
          <div
            class="page-title"
            v-if="pageTitle"
          >
            {{ pageTitle }}
          </div>
          <div
            class="page-subtitle"
            v-if="pageSubTitle"
          >
            {{ pageSubTitle }}
          </div>
        </template>

        <q-card
          :square="!isDesktopPlatform"
          class="column no-wrap col"
        >
          <q-banner
            class="bg-grey-3 text-grey-8"
          >
            <translate>The following parameters are used to compute the nutrients provided by the intermediate crop.</translate>
          </q-banner>

          <q-card-section>
            <div v-if="storePreviousCropExists">
              <div class="text-grey-8 q-mb-xs">
                <translate>Was there an intermediate crop before the main crop?</translate>
              </div>
              <q-btn-toggle
                v-model="storeIntermediateCropExists"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>

            <q-select
              v-if="storeIntermediateCropExists"
              v-model="storeIntermediateCropProfile"
              :options="intermediateCropOptions"
              option-value="id"
              :option-label="getRequafertiI18NFieldName('libelle')"
              filled
              :loading="isLoading"
              :label="$gettext('Intermediate crop profile')"
              @update:model-value="onIntermediateCropProfileChange"
              class="q-mt-md"
            />

            <q-select
              v-if="storeIntermediateCropExists && storeIntermediateCropProfile"
              v-model="storeIntermediateCropProductionLevel"
              :options="productionLevelOptions"
              option-value="type_prod_xid"
              :option-label="getRequafertiI18NFieldName('libelle_prod')"
              filled
              :loading="isLoading"
              :label="$gettext('Production level')"
              class="q-mt-md"
            />

            <div
              v-if="storeIntermediateCropExists && storeIntermediateCropProfile && soilSampleExists"
              class="q-mt-md"
            >
              <div class="text-grey-8 q-mb-xs">
                <translate>Was the effect of the intermediate crop on nitrogen supply already taken into account in the soil analysis?</translate>
              </div>
              <q-btn-toggle
                v-model="storeIntermediateCropTestSampleIncludesNitrogenEffect"
                :options="[{value: true, label: $gettext('Yes')}, {value: false, label: $gettext('No')}]"
                toggle-color="primary"
              />
            </div>
          </q-card-section>

          <!-- buttons -->
          <q-card-section class="q-mt-auto">
            <q-card-actions
              class="q-pa-none"
              vertical
              align="stretch"
            >
              <q-btn
                color="primary"
                text-color="white"
                :disable="!canContinue"
                @click="onClickNext"
              >
                <translate>Next</translate>
              </q-btn>
              <q-btn
                flat
                color="primary"
                @click="onClickPrevious"
              >
                <translate>Previous</translate>
              </q-btn>
            </q-card-actions>
          </q-card-section>
        </q-card>
      </div>
    </template>

    <template #footer>
      <Footer />
    </template>
  </GenericLayout>
</template>

<script>
import { PlatformMixin } from 'src/mixins/PlatformMixin'
import GenericLayout from 'src/layouts/GenericLayout'
import Header from 'src/components/layouts/Header'
import Footer from 'src/components/layouts/Footer'
import AlgorithmsMixins from 'src/pages/fieldbook/fertilization/algorithms/common/mixins/AlgorithmsMixins'
import RequafertiI18nMixin from 'src/pages/fieldbook/fertilization/algorithms/requaferti/mixins/RequafertiI18nMixin'
import queryRequafertiConfig from 'src/pages/fieldbook/fertilization/algorithms/requaferti/graphql/queryRequafertiConfig'

export default {
  name: 'RequafertiIntermediateCropProfilePage',
  components: {
    GenericLayout,
    Header,
    Footer
  },
  mixins: [PlatformMixin, AlgorithmsMixins, RequafertiI18nMixin],
  data () {
    return {
      requafertiConfig: null
    }
  },
  computed: {
    pageTitle () {
      return this.$gettext('Intermediate crop')
    },
    pageSubTitle () {
      return 'Requaferti'
    },
    canContinue () {
      return this.isParameterSet(this.storeIntermediateCropExists) &&
        (!this.storeIntermediateCropExists || (this.isParameterSet(this.storeIntermediateCropProfile) &&
        this.isParameterSet(this.storeIntermediateCropProductionLevel) &&
        (!this.soilSampleExists || this.isParameterSet(this.storeIntermediateCropTestSampleIncludesNitrogenEffect))))
    },
    isLoading () {
      return !this.requafertiConfig
    },
    intermediateCropOptions () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['culture_effet_cipan'] || []
    },
    productionLevelCombinations () {
      /* eslint-disable dot-notation */
      return this.requafertiConfig?.['effet_cipan']
    },
    productionLevelOptions () {
      if (!this.storeIntermediateCropProfile?.id || !this.productionLevelCombinations) {
        return []
      } else {
        return this.productionLevelCombinations.filter(level => level.type_cult_xid === this.storeIntermediateCropProfile.id)
      }
    },
    storeIntermediateCropExists: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropExists
      },
      set (v) {
        this.updateParameter('intermediateCropExists', v)
      }
    },
    storeIntermediateCropProfile: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropProfile
      },
      set (v) {
        this.updateParameter('intermediateCropProfile', v)
      }
    },
    storeIntermediateCropProductionLevel: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropProductionLevel
      },
      set (v) {
        this.updateParameter('intermediateCropProductionLevel', v)
      }
    },
    storeIntermediateCropTestSampleIncludesNitrogenEffect: {
      get () {
        return this.$store.state.fertilizationPlan.parameters.intermediateCropTestSampleIncludesNitrogenEffect
      },
      set (v) {
        this.updateParameter('intermediateCropTestSampleIncludesNitrogenEffect', v)
      }
    },
    storePreviousCropExists () {
      return this.$store.state.fertilizationPlan.parameters.previousCropExists
    },
    soilSampleExists () {
      return this.$store.state.fertilizationPlan.parameters.soilSampleExists
    }
  },
  async mounted () {
    // Load data from cache (or online if not in cache)
    await this.loadConfig('cache-first')

    // if there is no soil sample
    if (!this.soilSampleExists) {
      this.storeIntermediateCropTestSampleIncludesNitrogenEffect = null
    }

    // if there is no previous crop, there must be an intermediate crop
    if (!this.storePreviousCropExists) {
      this.storeIntermediateCropExists = true
    }

    // Refresh online data (do not wait until completion)
    this.loadConfig('network-only')
  },
  methods: {
    onClickNext () {
      // reset linked fields when no intermediate crop
      if (!this.storeIntermediateCropExists) {
        this.storeIntermediateCropProfile = null
        this.storeIntermediateCropProductionLevel = null
        this.storeIntermediateCropTestSampleIncludesNitrogenEffect = null
      }

      this.$router.replace({
        name: 'requafertiMeadowAndLucerne'
      })
    },
    onClickPrevious () {
      this.$router.replace({
        name: 'requafertiPreviousCropProfile'
      })
    },
    onIntermediateCropProfileChange () {
      // reset fields depending on selected crop when it changes
      this.storeIntermediateCropProductionLevel = null
    },
    async loadConfig (fetchPolicy) {
      const { data } = await this.$apollo.query({
        query: queryRequafertiConfig,
        fetchPolicy
      })
      this.requafertiConfig = data?.requaferti__config
    }
  }
}
</script>
